#pragma once

#include <string>

////////////////////////////////////////////////////////////////////////
// }N`
////////////////////////////////////////////////////////////////////////

// Ot@C̖O
#define LOG_FILE_NAME	"BkBsfilWrapper"
// Ot@C̊gq
#define LOG_FILE_EXT	"log"
// Ot@C[e[gTCŶl
#define LOG_FILE_SIZE_MAX	1048576
// O̍ő吢㐔
#define LOG_GENERATION_MAX	3

////////////////////////////////////////////////////////////////////////
// OǗ
////////////////////////////////////////////////////////////////////////

class CLogger
{
public:
	// Ox
	enum LogLevel { LOG_DEBUG, LOG_INFO, LOG_WARN, LOG_ERROR, LOG_USER, LOG_FATAL };

private:
	// RXgN^
	CLogger();
	// fXgN^
	~CLogger();

public:
	// Oo͂
	void Logging(const LogLevel logLevel, const char* pSourceFilename, const int sourceLineNumber, const char* pFuncname, const std::string* psData, const char* pMessage);

private:
	// O[e[g
	void LogRotate();

private:
	// o͂ł郍Õx
	LogLevel m_logLevel;
	// Ot@C
	std::string m_logFilepath;
	// Oo͂tH_
	std::string m_logFolder;
	// Oo͂̔rp
	CRITICAL_SECTION m_csLogger;

public:
	// 
	static void Initialize(const char* pLogFilepath, const char* pLogFolder, const char* pLogLevelStr);
	// OIuWFNg擾
	static CLogger* GetInstance();

private:
	// B̃OIuWFNg
	static CLogger s_logger;
	// Ox̕
	static const char* s_levelstr[];
};

////////////////////////////////////////////////////////////////////////
// Oo̓}NpbpNX
////////////////////////////////////////////////////////////////////////

class CLogging
{
public:
	// RXgN^
	CLogging(const CLogger::LogLevel logLevel, const char* pSourceFilename, const int sourceLineNumber, const char* pFuncname);

	// Oo͂
	void operator()(const char* pFormat, ...) const;
	void operator()(const std::string* psData, const char* pFormat, ...) const;
	void operator()(const int length, const char* pData, const char* pFormat, ...) const;

private:
	// o͂悤Ƃ郍Õx
	const CLogger::LogLevel m_logLevel;
	// \[X
	const char* m_pSourceFilename;
	// sԍ
	const int m_sourceLineNumber;
	// ֐
	const char* m_pFuncname;
};

////////////////////////////////////////////////////////////////////////
// Oo̓}N
////////////////////////////////////////////////////////////////////////

#define LOGGING_DEBUG	CLogging(CLogger::LOG_DEBUG, __FILE__, __LINE__, __FUNCNAME__)
#define LOGGING_INFO	CLogging(CLogger::LOG_INFO, __FILE__, __LINE__, __FUNCNAME__)
#define LOGGING_WARN	CLogging(CLogger::LOG_WARN, __FILE__, __LINE__, __FUNCNAME__)
#define LOGGING_ERROR	CLogging(CLogger::LOG_ERROR, __FILE__, __LINE__, __FUNCNAME__)
#define LOGGING_USER	CLogging(CLogger::LOG_USER, __FILE__, __LINE__, __FUNCNAME__)
#define LOGGING_FATAL	CLogging(CLogger::LOG_FATAL, __FILE__, __LINE__, __FUNCNAME__)
